/*
 * This file is part of qtutil
 * Copyright (c) 2000 David Deaven (deaven@execpc.com)
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Author: deaven $
 * $Id: QTAtom.h,v 1.3 2000/10/14 04:47:06 deaven Exp $
 */

#ifndef __QTAtom__
#define __QTAtom__

#include <stdio.h>

class QTAtomImpl;

class QTAtom {
public:
    QTAtom() : Impl(NULL) { }
    QTAtom(const QTAtom& other) : Impl(other.Impl) { }
    ~QTAtom() { }

    const char* type() const;

    unsigned long size() const;
    QTAtom* children(int* count);
    void print(int indent = 0);

    QTAtom* findChildrenOfType(const char* type, int* count);
    QTAtom findChildOfType(const char* type);

    QTAtom& operator=(const QTAtom& other) { Impl = other.Impl; return *this; }

    static QTAtom parseFile(FILE* fptr);
    QTAtomImpl* impl() { return Impl; }

protected:
    QTAtomImpl* Impl;
    QTAtom(QTAtomImpl* impl) : Impl(impl) { }
    int findChildrenOfTypeRecurse(const char* type, QTAtom* atoms, int * count);
};

#endif // __QTAtom__
