/*
 * This file is part of qtutil
 * Copyright (c) 2000 David Deaven (deaven@execpc.com)
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Author: deaven $
 * $Id: QTFrameExtractor.h,v 1.2 2000/10/14 04:47:06 deaven Exp $
 */

#ifndef __QTFrameExtractor__
#define __QTFrameExtractor__

#include <stdio.h>
#include "QTAtom.h"

class QTFrameExtractor {
public:
    QTFrameExtractor(QTAtom root) : Root(root) { }
    ~QTFrameExtractor() { }
    
    int extractAll(const char* prefix);
    int extract(int frameno, FILE* f);
    int createTime();
    int size();

private:
    QTAtom Root;
};

#endif // __QTFrameExtractor__
